<?

require_once("testcase_ODB.php");

class DelegationTest extends ODBTest {
    public function test_dl(){
        print("Testing Delegation Object:\n");
        $dl = new Delegation();
        $this->assertIsA($dl, 'Delegation');

        $sp1 = self::create_sp('SP1');
        $user1 = self::create_user($sp1->id(), 'User1');
        $user2 = self::create_user($sp1->id(), 'User2');

        $sp2 = self::create_sp('SP2');
        $user3 = self::create_user($sp2->id(), 'User3');
        $user4 = self::create_user($sp2->id(), 'User4');

        print("\tcreate not exist: ");
        $dl->src_user('123');
        $dl->dst_user($user3->id());
        try {
           $dl->save();
        }
        catch (Exception $e){}

        $expect = new ExceptionExpectation('PDOException');
        $this->assert($expect, $e);
        print("ok\n");

        print("\tcreate: ");
        $dl->src_user($user1->id());
        $dl->dst_user($user3->id());
        $dl->save();
        $dl1_id = $dl->id();
        print("ok\n");

        print("\tcreate second: ");
        $dl = new Delegation();
        $dl->src_user($user3->id());
        $dl->dst_user($user4->id());
        $dl->save();
        $dl2_id = $dl->id();
        print("ok\n");

        print("\tcreate third: ");
        $dl = new Delegation();
        $dl->src_user($user4->id());
        $dl->dst_user($user2->id());
        $dl->save();
        $dl3_id = $dl->id();
        print("ok\n");

        print("\tload_by_src_dst not exists: ");
        $dl->load_by_src_dst($user1->id(), $user2->id());
        $this->assertNull($dl->id());
        print("ok\n");
        print("\tload_by_src_dst exists: ");
        $dl->load_by_src_dst($user1->id(), $user3->id());
        $this->assertEqual($dl->id(), $dl1_id);
        print("ok\n");

        print("\tget_src_users: ");
        $src_users = Delegation::get_src_user_ids('User2', $sp1->id());
        $this->assertEqual(count($src_users), 3);
        print("ok\n");

        print("\tget_dst_users: ");
        $dst_users = Delegation::get_dst_user_ids('User1', $sp1->id());
        $this->assertEqual(count($dst_users), 3);
        print("ok\n");

        print("done.\n\n");

    }
}
?>