<?php
require_once('base/service.php');
require_once('SP/CertificateAuth.php');

// Can you read that name? :)
class test_SP_CertificateAuthTest_TestSubject extends SP_CertificateAuth {

    /**
     * This function is overridden to isolate access to database
     *
     * @param string $cert_field
     * @param string $cert_value
     */
    protected function load_by_cert($cert_field, $cert_value) {
        switch ($cert_field) {
            case 'cert':
                if ('current_certificate_value' == $cert_value) {
                    return 'me';
                }
                break;
            case 'cert_old':
                if ('old_certificate_value' == $cert_value) {
                    return 'me';
                }
                break;
            default:
        }
        return null;
    }

}


class test_SP_CertificateAuthTest extends UnitTestCase {

    private $cert_auth;

    private $request;

    public function setUp() {
        $this->cert_auth = new test_SP_CertificateAuthTest_TestSubject($this->service_mock);
        $this->request = new Request();
    }

    public function tearDown () {
        unset($this->request);
        unset($this->cert_auth);
    }

    function testNoCert() {
        $this->assertNull($this->cert_auth->process_request($this->request));
        $this->assertFalse(array_key_exists('principal', $this->request->attributes));
    }


    function testNoCert2() {
        $this->request->server['SSL_CLIENT_CERT'] = '';
        $this->assertNull($this->cert_auth->process_request($this->request));
        $this->assertFalse(array_key_exists('principal', $this->request->attributes));
    }

    function testCert1() {
        $this->request->server['SSL_CLIENT_CERT'] = 'current_certificate_value';
        $this->assertNull($this->cert_auth->process_request($this->request));
        $this->assertEqual('me', $this->request->attributes['principal']);
    }


    function testCert2() {
        $this->request->server['SSL_CLIENT_CERT'] = 'old_certificate_value';
        $this->assertNull($this->cert_auth->process_request($this->request));
        $this->assertEqual('me', $this->request->attributes['principal']);
    }
}

// $t = new test_SP_CertificateAuthTest();
// $t->run(new TextReporter());

?>