<?

require_once("lib/SslUtils.php");
require_once("testcase_ODB.php");

class SpUserTest extends ODBTest {

    public function test_user(){
print("Testing SpUser Object:\n");
        $sp = self::create_sp('SP1');
        $user = new SpUser();
        $this->assertIsA($user, 'SpUser', "\$user is an object of SpUser");

print("\tcreate user: ");
        $user->create("User1", $sp->id());
        $this->assertNotNull($user->id(), "\$user->create() initializes object ID");
        $this->assertEqual($user->sp_login(), 'User1', "\$user->create() initializes user Login");
        $this->assertEqual($user->sp_id(), $sp->id(), "\$user->create() initializes user SP ID");
        $user->save();
print("ok\n");

print("\tload user load_by_login_sp: ");
        $user1 = new SpUser();
        $user1->load_by_login_sp($user->sp_login(), $user->sp_id());
        $this->assertEqual($user1->id(), $user->id(), "Construct with ID initializes and loads object");
        $this->assertEqual($user1->sp_login(), $user->sp_login(), "\$user1->sp_login() same as \$user->sp_login()");
        $this->assertEqual($user1->sp_id(), $user->sp_id(), "\$user1->sp_id() same as \$user->sp_id()");
print("ok\n");

// this test to be performed in ODB
print("\tsave user: ");
        $sp1 = self::create_sp('SP2');
        $user1->sp_login("User2");
        $user1->sp_id($sp1->sp_id());
        $user1->save();
        $user->load_by_id($user1->id());
        $this->assertEqual($user->sp_login(), 'User2', "\$user->load_by_id() initializes user Login");
        $this->assertEqual($user->sp_id(), $sp1->id(), "\$user->load_by_id() initializes user SP ID");
print("ok\n");
// /this test to be performed in ODB

print("\tFI assignment: ");
        $fi = self::create_fi($user->id());
        $this->assertEqual($user->get_fed_id(), $fi->id(), "\$user->get_fed_id() works fine");
print("ok\n");

print("\tload_or_create using load feature: ");
        $user2 = new SpUser();
        $user2->load_or_create("User2", $sp1->id());
        $this->assertEqual($user2->id(), $user->id(), "\$user->load_or_create() loaded proper user");
print("ok\n");

print("\tload_or_create using create feature: ");
        $user2->load_or_create("User3", $sp1->id());
        $this->assertNotEqual($user2->id(), $user->id(), "\$user->load_or_create() created new user");
        $this->assertEqual($user2->sp_login(), 'User3', "\$user->load_or_create() set user Login");
        $this->assertEqual($user2->sp_id(), $sp1->id(), "\$user->load_or_create() set user SP ID");
print("ok\n");

print("\tdeleting removes delegation: ");
        $user2_id = $user2->id();
        $del = self::create_delegation($user2->id(), $user->id());
        $user2->delete();
        $del->load();
        $this->assertNull($del->id(), "\$user->delete() Removes delegation if user is a delegation src_user");
print("ok\n");

//TODO fix delete_time update triggers
print("\tdeleting removes from FI: ");
        $fi->load_by_sp_user_id($user2_id);
        $this->assertNull($fi->id(), "\$user->delete() Removes user from federation");
print("ok\n");
print("done.\n\n");

    }
}

?>