<?php
require_once("testcase_header.php");
require_once("lib/PostData.php");

class PostDataTest extends UnitTestCase {

    private $non_alphanum = '~!@#$%^&*()_+}|{":?><';

    private $values;

    private $urlencoded_values = 'a%7E%21%40%23%24%25%5E%26%2A%28%29_%2B%7D%7C%7B%22%3A%3F%3E%3C=1&nebuchadnezzaaar=something+eloquent+%7E%21%40%23%24%25%5E%26%2A%28%29_%2B%7D%7C%7B%22%3A%3F%3E%3C';

    private $content_type = 'application/x-www-form-urlencoded';

	function __construct() {
		$this->UnitTestCase();
	}

	public function setUp() {
	    $this->values = array('a' . $this->non_alphanum => 1, 'nebuchadnezzaaar' => 'something eloquent ' . $this->non_alphanum);
	}

	function testEncode() {
		$content_type = 'application/x-www-form-urlencoded';
		$this->assertEqual($this->urlencoded_values, lib_PostData::encode($this->content_type, $this->values));
	}

	function testEncode2() {
		try {
		  lib_PostData::encode('multipart/form-data', array());
		  $this->fail('Exception expected');
		} catch (Exception $e) {
		   $e; // expected
		}
	}

	function testparse() {
		$this->assertEqual($this->values, lib_PostData::parse($this->content_type, $this->urlencoded_values));
	}

	function testparse2() {
		try {
		  lib_PostData::parse('multipart/form-data', 'asdasdfasdf');
		  $this->fail('Exception expected');
		} catch (Exception $e) {
		   $e; // expected
		}
	}

	function testLoop() {
        $this->assertEqual(
            $this->urlencoded_values,
            lib_PostData::encode($this->content_type,
                lib_PostData::parse(
                    $this->content_type,
                    $this->urlencoded_values)));
	    $this->assertEqual(
	       $this->values,
	       lib_PostData::parse(
	           $this->content_type,
	           lib_PostData::encode(
	               $this->content_type,
	               $this->values)));
	}

}

//$t = new PostDataTest();
//$t->run(new TextReporter());


?>