<?php
require_once("testcase_header.php");

require_once("lib/props.php");


class PropsTest extends UnitTestCase {

	function PropsTest() {
		$this->UnitTestCase();
	}

	function testMake() {
		$d = array("a" => "1", "b" => 2, 3 => "c");
		$s = properties_to_string($d);
		$this->assertEqual($s, "a = 1\nb = 2\n3 = c\n");
	}

	function testEmptyKey() {
		$d = array("a" => "1", " " => 2);
		try {
			$s = properties_to_string($d);
			$this->fail("Exception expected");
		} catch (Exception $e) {
			$this->assertEqual($e->getCode(), 500);
		}
	}

	function testParse() {
		// $this->fail("Test not yet implemented");
		$dict = properties_parse_string("a = 1\nb = 2\n3 = c\n");
		$this->assertEqual($dict, array("a" => "1", "b" => 2, 3 => "c"));

		$dict = properties_parse_string("\n   \nb = 2");
		$this->assertEqual($dict, array("b" => 2));
	}

	function testLoop() {
		$d = array("a" => "1", "b" => 2, 3 => "c");
		$this->assertEqual(properties_parse_string(properties_to_string($d)), $d);
		$d = array();
		$this->assertEqual(properties_parse_string(properties_to_string($d)), $d);
		$d = array("enom" => "enum");
		$this->assertEqual(properties_parse_string(properties_to_string($d)), $d);
	}
}


// $t = new PropsTest();
// $t->run(new TextReporter());


?>