<?php
require_once("testcase_header.php");

require_once("base/service_base.php");
require_once("base/request.php");
require_once("toy_service.php");


class SimpleTestService extends ServiceBase {

	private $test_sase;

	public function __construct($test_case) {
		$this->test_case = $test_case;
	}

	function doMETHOD($request) {
		$this->test_case->assertEqual($request->server["REQUEST_METHOD"], "METHOD");
		return "hello";
	}
}


class ServiceBaseTest extends UnitTestCase {

	private static function makeEmptyRequest($method_name) {
		$r = new Request(false);
		$r->server["REQUEST_METHOD"] = $method_name;
		return $r;
	}

	private function testNotImplementedMethod($method_name) {
	    $method_is_not_implemented_code = 501; // Was 405

		$s = new ServiceBase();
		$r = $s->process_request(ServiceBaseTest::makeEmptyRequest($method_name));
		$this->assertPattern("/not implemented/i", $r->reason_phrase);
		$this->assertEqual($method_is_not_implemented_code, $r->status_code);
	}

	public function testNotImplementedMethodS() {
		$this->testNotImplementedMethod("GET");
		$this->testNotImplementedMethod("PUT");
		$this->testNotImplementedMethod("POST");
		$this->testNotImplementedMethod("DELETE");
		$this->testNotImplementedMethod("SCHZooMONDRIZEIT");
	}

	public function testSubclassing() {
		$s = new SimpleTestService($this);
		// No exceptions should be thrown:
		$this->assertEqual("hello", $s->process_request(ServiceBaseTest::makeEmptyRequest("METHOD")));
	}

	public function testListMethods() {
		$s = new ToyService("halo", true);
		$this->assertEqual(array("GET", "POST"), $s->getAllowedMethods());
	}

}


// $test = new ServiceBaseTest();
// $test->run(new TextReporter());


?>