<?php
require_once('base/url_template.php');

class UrlTemplateTest extends UnitTestCase {

	function testNoreplaces() {
	    $ln = 'somestring';
	    $params = array('a'=>'b');

		$this->assertEqual('http://bozo.xul/' . $ln, make_url_from_template('http://bozo.xul', $ln, $params));

		$ln .= '((er))';
		$this->assertEqual($ln, make_url_from_template('', $ln, $params));
	}

	function testReplace() {
	    $ln = 'somes((a))tring';
	    $params = array('a' => 'B', 'b' => 'a');
		$this->assertEqual('somesBtring', make_url_from_template('', $ln, $params));

		$ln = 'somes((c))tring((b))';
		$this->assertEqual('a/somes((c))tringa', make_url_from_template('a', $ln, $params));
	}

	function testEncoding() {
	    $ln = '/((a))blog';
	    $params = array('a' => 'read this: NO!');
		$this->assertEqual('/read+this%3A+NO%21blog', make_url_from_template('', $ln, $params));
	}

}

// $t = new UrlTemplateTest();
// $t->run(new TextReporter());

?>