<?php
require_once("testcase_header.php");
require_once("lib/util.php");

class UtilTest extends UnitTestCase {

	function __construct() {
		$this->UnitTestCase();
	}

	public function setUp() {
	}

	public function tearDown () {
	}

	private function testPack($value) {
		$this->assertEqual($value, unpack_value(pack_value($value)));
	}

	public function testPacking() {
		$this->testPack("");
		$this->testPack("asdf ,m asd,f asdfoi7 )(*&^q2u 3k)(&*Ykjb asdfv");
		$this->testPack(10);
		$this->testPack(array(1, 2, 3));
		$this->testPack(array(1 => "asd", 2 => "fgh"));
	}

	public function testMakeNewId() {
	    $this->assertTrue(strlen(make_new_id()) >= 32);
        $seen = array();
	    for ($len = 0; $len < 80; ++$len) {
	       $id = make_new_id($len);
	       $this->assertTrue(strlen($id) >= $len);
	       $this->assertFalse(in_array($id, $seen));
	       array_push($seen, $id);
	    }
	}
}

// $test = new UtilTest();
// $test->run(new TextReporter());

?>